From 69047935dd4a9549d238cbc457e9c3cfa37386ae Mon Sep 17 00:00:00 2001
From: Yichao Yu <yyc1992@gmail.com>
Date: Mon, 4 Nov 2013 08:15:40 -0500
Subject: [PATCH] [gtk2] fix old config file...

---
 gtk2/common/config_file.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

diff --git a/gtk2/common/config_file.c b/gtk2/common/config_file.c
index 34e4877..cf01cad 100644
--- a/gtk2/common/config_file.c
+++ b/gtk2/common/config_file.c
@@ -1210,7 +1210,8 @@ bool qtcReadConfig(const char *file, Options *opts, Options *defOpts)
             char *filename = qtcCatStrs(qtcConfDir(), CONFIG_FILE);
             bool rv = false;
             if (!qtcIsRegFile(filename)) {
-                filename = qtcFillStrs(filename, qtcConfDir(), OLD_CONFIG_FILE);
+                filename = qtcFillStrs(filename, qtcConfDir(),
+                                       "/../" OLD_CONFIG_FILE);
             }
             rv = qtcReadConfig(filename, opts, defOpts);
             free(filename);
-- 
1.9.1