From 020b70404f6202490d5ca131f0ec084355cb98e3 Mon Sep 17 00:00:00 2001
From: Yichao Yu <yyc1992@gmail.com>
Date: Mon, 3 Feb 2014 09:54:13 -0500
Subject: [PATCH] [misc] use -std=c++0x since gcc < 4.7 do not recognise c++11

---
 CMakeLists.txt | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

diff --git a/CMakeLists.txt b/CMakeLists.txt
index 5c9038f..b2be588 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -136,8 +136,9 @@ cmake_c_fix_include_path(lib/cairo qtcurve-cairo)
 cmake_c_add_flags(CMAKE_C_FLAGS -Wall -Wextra -std=gnu99)
 # Register storage class is deprecated in C++11 but is still used in Qt.
 # Use compiler option to suppress the warning in clang++.
+# -std=c++0x is deprecated but gcc < 4.7 do not recognise c++11 ....
 cmake_c_add_flags(CMAKE_CXX_FLAGS -Wall -Wextra
-  -Wno-deprecated-register -std=c++11)
+  -Wno-deprecated-register -std=c++0x)
 cmake_c_add_flags(CMAKE_SHARED_LINKER_FLAGS -Wl,--as-needed -Wl,--no-undefined)
 cmake_c_add_flags(CMAKE_MODULE_LINKER_FLAGS -Wl,--as-needed -Wl,--no-undefined)
 add_definitions("-D_GNU_SOURCE -pthread")
-- 
1.8.5.1