Index: configure
===================================================================
--- configure	(revision 72192)
+++ configure	(working copy)
@@ -3794,7 +3794,7 @@
 wx_major_version_number=2
 wx_minor_version_number=9
 wx_release_number=4
-wx_subrelease_number=0
+wx_subrelease_number=1
 
 WX_RELEASE=$wx_major_version_number.$wx_minor_version_number
 WX_VERSION=$WX_RELEASE.$wx_release_number
Index: Makefile.in
===================================================================
--- Makefile.in	(revision 72192)
+++ Makefile.in	(working copy)
@@ -2619,6 +2619,7 @@
 	wx/gtk/dataform.h \
 	wx/gtk/dataobj.h \
 	wx/gtk/dataobj2.h \
+	wx/gtk/dc.h \
 	wx/gtk/dnd.h \
 	wx/gtk/evtloop.h \
 	wx/gtk/evtloopsrc.h \
@@ -2647,6 +2648,7 @@
 	wx/gtk/dataform.h \
 	wx/gtk/dataobj.h \
 	wx/gtk/dataobj2.h \
+	wx/gtk/dc.h \
 	wx/gtk/dnd.h \
 	wx/gtk/evtloop.h \
 	wx/gtk/evtloopsrc.h \
Index: include/wx/version.h
===================================================================
--- include/wx/version.h	(revision 72192)
+++ include/wx/version.h	(working copy)
@@ -29,7 +29,7 @@
 #define wxMAJOR_VERSION      2
 #define wxMINOR_VERSION      9
 #define wxRELEASE_NUMBER     4
-#define wxSUBRELEASE_NUMBER  0
+#define wxSUBRELEASE_NUMBER  1
 #define wxVERSION_STRING   wxT("wxWidgets 2.9.4")
 
 /*  nothing to update below this line when updating the version */
Index: configure.in
===================================================================
--- configure.in	(revision 72192)
+++ configure.in	(working copy)
@@ -44,7 +44,7 @@
 wx_major_version_number=2
 wx_minor_version_number=9
 wx_release_number=4
-wx_subrelease_number=0
+wx_subrelease_number=1
 
 WX_RELEASE=$wx_major_version_number.$wx_minor_version_number
 WX_VERSION=$WX_RELEASE.$wx_release_number
Index: build/bakefiles/files.bkl
===================================================================
--- build/bakefiles/files.bkl	(revision 72192)
+++ build/bakefiles/files.bkl	(working copy)
@@ -1104,6 +1104,7 @@
     wx/gtk/dataform.h
     wx/gtk/dataobj.h
     wx/gtk/dataobj2.h
+    wx/gtk/dc.h
     wx/gtk/dnd.h
     wx/gtk/evtloop.h
     wx/gtk/evtloopsrc.h
Index: wxPython/src/helpers.cpp
===================================================================
--- wxPython/src/helpers.cpp	(revision 72192)
+++ wxPython/src/helpers.cpp	(working copy)
@@ -28,11 +28,6 @@
 #ifdef __WXGTK__
 #include <gtk/gtk.h>
 #include <gdk/gdkx.h>
-#ifdef __WXGTK20__
-#include <wx/gtk/private/win_gtk.h>
-#else
-#include <wx/gtk1/win_gtk.h>
-#endif
 #define GetXWindow(wxwin) (wxwin)->m_wxwindow ? \
                           GDK_WINDOW_XWINDOW((wxwin)->m_wxwindow->window) : \
                           GDK_WINDOW_XWINDOW((wxwin)->m_widget->window)
Index: wxPython/docs/CHANGES.txt
===================================================================
--- wxPython/docs/CHANGES.txt	(revision 72192)
+++ wxPython/docs/CHANGES.txt	(working copy)
@@ -3,6 +3,16 @@
 Recent Changes for wxPython
 =====================================================================
 
+2.9.4.1
+-------
+* 24-July-2012
+
+A quick patch release to fix some C++ headers for the wxGTK port not
+getting installed, causing a build error in wxPython.
+
+
+
+
 2.9.4.0
 -------
 * 21-July-2012
Index: wxPython/cfg_version.py
===================================================================
--- wxPython/cfg_version.py	(revision 72192)
+++ wxPython/cfg_version.py	(working copy)
@@ -4,5 +4,5 @@
 VER_MAJOR        = 2      # The first three must match wxWidgets
 VER_MINOR        = 9
 VER_RELEASE      = 4
-VER_SUBREL       = 0      # wxPython release num for x.y.z release of wxWidgets
+VER_SUBREL       = 1      # wxPython release num for x.y.z release of wxWidgets
 VER_FLAGS        = ""     # release flags, such as prerelease or RC num, etc.