--- origsrc/zlib-1.2.11/gzguts.h	2017-01-01 01:37:10.000000000 -0600
+++ src/zlib-1.2.11/gzguts.h	2017-03-03 15:38:57.326064400 -0600
@@ -39,7 +39,7 @@
 #  include <io.h>
 #endif
 
-#if defined(_WIN32) || defined(__CYGWIN__)
+#if defined(_WIN32)
 #  define WIDECHAR
 #endif
 
--- origsrc/zlib-1.2.11/win32/zlib.def	2017-01-01 01:37:10.000000000 -0600
+++ src/zlib-1.2.11/win32/zlib.def	2017-03-03 15:41:32.326386500 -0600
@@ -91,4 +91,3 @@ EXPORTS
     inflateCodesUsed
     inflateResetKeep
     deflateResetKeep
-    gzopen_w
--- origsrc/zlib-1.2.11/zlib.h	2017-01-15 11:29:40.000000000 -0600
+++ src/zlib-1.2.11/zlib.h	2017-03-03 15:37:21.402184600 -0600
@@ -1893,7 +1893,7 @@ ZEXTERN int            ZEXPORT inflateVa
 ZEXTERN unsigned long  ZEXPORT inflateCodesUsed OF ((z_streamp));
 ZEXTERN int            ZEXPORT inflateResetKeep OF((z_streamp));
 ZEXTERN int            ZEXPORT deflateResetKeep OF((z_streamp));
-#if (defined(_WIN32) || defined(__CYGWIN__)) && !defined(Z_SOLO)
+#if defined(_WIN32) && !defined(Z_SOLO)
 ZEXTERN gzFile         ZEXPORT gzopen_w OF((const wchar_t *path,
                                             const char *mode));
 #endif